# Smartsheet

### Overview

The Veza integration for Smartsheet discovers workspaces and folders in a Smartsheet Business account, along with local users and groups. Veza can also show the granular level of access within Smartsheet via effective permissions and roles.

See [notes and supported entities](#notes-and-supported-entities) for more details.

### Configuring Smartsheet

Before you can add the integration to Veza, you will need an API key for a Smartsheet admin user, required to gather all users, groups, roles, and permissions.

{% hint style="info" %}
You can limit integration access to Smartsheet by using an API token for a **Licensed User** with **Resource: Viewer** access. When configured, Veza will discover resources (Workspaces and Folders) that the Smartsheet user can view.
{% endhint %}

#### Create a Smartsheet access token

1. Log in to Smartsheet as an administrator.
2. Click the **Account** button in the lower-left corner of the Smartsheet screen. Click **Personal Settings**.

   ![Opening Smartsheet personal settings.](/files/3969Tf7Ag5gaQffOzZdC)
3. Open the **API Access** tab.
4. Click the **Generate new access token** button to create a token.

   ![Generating a Smartsheet API token](/files/tMG7UchGbUHykcN03LLV)
5. Save the token, which will only appear once.

### Add a Smartsheet integration to Veza

1. In Veza, go to the **Integrations** page.
2. Click **Add Integration** and search for **Smartsheet**. Click on it and click **Next** to add an integration.
3. Enter the required information.
4. Click **Create Integration** to save the configuration.

| Field            | Notes                                                                     |
| ---------------- | ------------------------------------------------------------------------- |
| Insight Point    | Choose whether to use the default data plane or a deployed Insight Point. |
| Name             | A friendly name to identify the unique integration.                       |
| Smartsheet Token | API token from the previous steps.                                        |

### Notes and supported entities

This integration uses the Open Authorization API template for custom applications. The following graph entities are supported in the Veza graph:

* Smartsheet Business → Custom Application
* Smartsheet Workspaces → Resource
  * Smartsheet Folders → Sub-Resources
* Smartsheet Group → Local Group
* Smartsheet User → Local User
* Smartsheet User Role → Local Role
* Smartsheet Permissions → Local Permission

#### Smartsheet Group

| Attribute   | Description                 |
| ----------- | --------------------------- |
| id          | Group ID                    |
| name        | Group name                  |
| description | Group description           |
| owner       | Group owner’s email address |
| ownerId     | Group owner's user Id       |
| createdAt   | Group Creation Time         |
| modifiedAt  | Group Modified Time         |

#### Smartsheet User

| Attribute            | Description                                                                                                         |
| -------------------- | ------------------------------------------------------------------------------------------------------------------- |
| id                   | User Id                                                                                                             |
| admin                | Default: `false`. Indicates whether the user is a system admin (can manage user accounts and the business account). |
| email                | User's primary email address                                                                                        |
| name                 | User's full name (read-only)                                                                                        |
| firstName            | User’s First Name                                                                                                   |
| lastName             | User’s Last Name                                                                                                    |
| groupAdmin           | Default: `false`. Indicates whether the user is a group admin (can create and edit groups).                         |
| lastLogin            | Last login time of the current user                                                                                 |
| status               | User status, set to one of the values: `ACTIVE`, `DECLINED`, `PENDING`, or `DEACTIVATED`                            |
| licensedSheetCreator | Indicates whether the user is a licensed user (can create and own sheets). Default: `false`                         |
| resourceViewer       | Indicates whether the user is a resource viewer (can access resource views). Default: `false`                       |
| sheetCount           | The number of sheets owned by the current user within the organization account                                      |

#### Smartsheet Workspace

| Attribute   | Description                                                                                                                         |
| ----------- | ----------------------------------------------------------------------------------------------------------------------------------- |
| id          | Workspace Id                                                                                                                        |
| name        | Workspace name                                                                                                                      |
| accessLevel | The user level role at which the workspace is accessed. One of `ADMIN`, `COMMENTER`, `EDITOR`, `EDITOR_SHARE`, `OWNER`, or `VIEWER` |

#### Smartsheet Folder

| Attribute | Description                     |
| --------- | ------------------------------- |
| id        | Folder Id                       |
| folders   | Folders contained in the folder |
| name      | Folder name                     |

#### Smartsheet Permissions

In Smartsheet, sheets, templates, and workspaces have an `Access Level` attribute that describes the current user's access level to that object. This corresponds directly to the sharing and access controls of Smartsheet that are available through the Smartsheet UI. Veza models access levels in Smartsheet using roles.

Access levels can be one of the following, indicating the range of permissions granted to assigned users:

| Value         | Description                                                                                    |
| ------------- | ---------------------------------------------------------------------------------------------- |
| ADMIN         | The user can edit and share the resource, and alter the resource structure.                    |
| EDITOR        | The user can edit the resource, but not alter the structure of, delete, or share the resource. |
| EDITOR\_SHARE | The same as EDITOR, but with the ability to share the resource with other users.               |
| OWNER         | The user has full control over the resource.                                                   |
| VIEWER        | The user has read-only access to the resource.                                                 |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.veza.com/4yItIzMvkpAvMVFAamTf/integrations/integrations/smartsheet.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
